//Guitar.cs

//------------------------------------------------------------------------------

datablock AudioProfile(Guitar01Sound)
{
   filename    = "./Guitar_01.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar02Sound)
{
   filename    = "./Guitar_02.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar03Sound)
{
   filename    = "./Guitar_03.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar04Sound)
{
   filename    = "./Guitar_04.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar05Sound)
{
   filename    = "./Guitar_05.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar06Sound)
{
   filename    = "./Guitar_06.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar07Sound)
{
   filename    = "./Guitar_07.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar08Sound)
{
   filename    = "./Guitar_08.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar09Sound)
{
   filename    = "./Guitar_09.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Guitar10Sound)
{
   filename    = "./Guitar_10.wav";
   description = AudioClosest3d;
   preload = true;
};

//////////
// item //
//////////----------------------------------------------------------------------
datablock ItemData(GuitarItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./Guitar.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Guitar";
	iconName = "./icon_Guitar";
	doColorShift = false;
	colorShiftColor = "1 1 1 1";

	image = GuitarImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////----------------------------------------------------------------
datablock ShapeBaseImageData(GuitarImage)
{
   // Basic Item properties
   shapeFile = "./GuitarState1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Guitar;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   	casing = gunShellDebris;
	shellExitDir        = "0.0 0.0 0.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 0.0;	
	shellVelocity       = 0.0;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PrePlay";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PrePlay";
	stateScript[2]                  = "onPrePlay";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.05;
	stateTransitionOnTimeout[2]     = "Play";

	stateName[3]                    = "Play";
	stateTransitionOnTimeout[3]     = "CheckPlay";
	stateTimeoutValue[3]            = 0.02;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Play";
	stateScript[3]                  = "onPlay";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckPlay";
	stateTransitionOnTriggerUp[4]	= "StopPlay";
	stateTransitionOnTriggerDown[4]	= "Play";

	
	stateName[5]                    = "StopPlay";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.02;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopPlay";
	stateScript[5]                  = "onStopPlay";
};

////////////////
//weapon image//
////////////////----------------------------------------------------------------
datablock ShapeBaseImageData(GuitarImage2)
{
   // Basic Item properties
   shapeFile = "./GuitarState2.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Guitar;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   	casing = gunShellDebris;
	shellExitDir        = "0.0 0.0 0.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 0.0;	
	shellVelocity       = 0.0;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PrePlay";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PrePlay";
	stateScript[2]                  = "onPrePlay";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.05;
	stateTransitionOnTimeout[2]     = "Play";

	stateName[3]                    = "Play";
	stateTransitionOnTimeout[3]     = "CheckPlay";
	stateTimeoutValue[3]            = 0.02;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Play";
	stateScript[3]                  = "onPlay";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckPlay";
	stateTransitionOnTriggerUp[4]	= "StopPlay";
	stateTransitionOnTriggerDown[4]	= "Play";

	
	stateName[5]                    = "StopPlay";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.02;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopPlay";
	stateScript[5]                  = "onStopPlay";
};

//------------------------------------------------------------------------------

function GuitarImage::onMount(%this,%obj,%slot,$player)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playthread(2, armReadyBoth);
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook");
}

function GuitarImage::onUnMount(%this,%obj,%slot,$Switched)
{
	Parent::onMount(%this,%obj,%slot,$Switched);
	%obj.playthread(2, root);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

function GuitarImage2::onMount(%this,%obj,%slot,$player)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.playthread(2, armReadyBoth);
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook");
}

function GuitarImage2::onUnMount(%this,%obj,%slot,$Switched)
{

	Parent::onMount(%this,%obj,%slot,$Switched);

	%obj.playthread(2, root);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
	{
		applyDefaultCharacterPrefs(%obj);
	}
}

//------------------------------------------------------------------------------

package AltFire
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "GuitarImage" || %player.getMountedImage(0).getName() $= "GuitarImage2") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "GuitarImage":

                                                %player.mountImage(GuitarImage2,0);

                                        case "GuitarImage2":

                                                %player.mountImage(GuitarImage,0);

                                }

				$Switched = true;
                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
activatePackage(AltFire);

//------------------------------------------------------------------------------

function GuitarImage::onPrePlay(%this,%obj,%pos,$random)
{
	%obj.playthread(2, plant);
	%pos = %obj.getTransform();

	if($random == 0)
	{
		serverplay3d(Guitar01Sound,%pos);

	}
	else if($random == 1)
	{
		serverplay3d(Guitar02Sound,%pos);

	}
	else if($random == 2)
	{
		serverplay3d(Guitar03Sound,%pos);

	}
	else if($random == 3)
	{
		serverplay3d(Guitar04Sound,%pos);

	}
	else if($random == 4)
	{
		serverplay3d(Guitar05Sound,%pos);

	}
	else if($random == 5)
	{
		serverplay3d(Guitar06Sound,%pos);

	}
	else if($random == 6)
	{
		serverplay3d(Guitar07Sound,%pos);

	}
	else if($random == 7)
	{
		serverplay3d(Guitar08Sound,%pos);

	}
	else if($random == 8)
	{
		serverplay3d(Guitar09Sound,%pos);

	}
	else if($random == 9)
	{
		serverplay3d(Guitar10Sound,%pos);
		$random = 0;

	}
	else
	{
		echo("Error on the Guitar!");
		$random = 0;
	}

	$random++;
}

//------------------------------------------------------------------------------

function GuitarImage2::onPrePlay(%this,%obj,%pos,$random)
{
	%obj.playthread(2, plant);
	%pos = %obj.getTransform();

	if($random == 0)
	{
		serverplay3d(Guitar01Sound,%pos);
		$random = 9;

	}
	else if($random == 1)
	{
		serverplay3d(Guitar02Sound,%pos);

	}
	else if($random == 2)
	{
		serverplay3d(Guitar03Sound,%pos);

	}
	else if($random == 3)
	{
		serverplay3d(Guitar04Sound,%pos);

	}
	else if($random == 4)
	{
		serverplay3d(Guitar05Sound,%pos);

	}
	else if($random == 5)
	{
		serverplay3d(Guitar06Sound,%pos);

	}
	else if($random == 6)
	{
		serverplay3d(Guitar07Sound,%pos);

	}
	else if($random == 7)
	{
		serverplay3d(Guitar08Sound,%pos);

	}
	else if($random == 8)
	{
		serverplay3d(Guitar09Sound,%pos);

	}
	else if($random == 9)
	{
		serverplay3d(Guitar10Sound,%pos);
	}
	else
	{
		echo("Error on the Guitar!");
		$random = 9;
	}
	$random--;
}

//------------------------------------------------------------------------------

function GuitarImage::onStopPlay(%this, %obj, %slot)
{	
	//%obj.playthread(2, root);
}

function GuitarImage2::onStopPlay(%this, %obj, %slot)
{	
	//%obj.playthread(2, root);
}